importScripts('polyfill.js', 'Ice.js', 'Ansjer.js', 'MsgType.js');

let msgMap;
let bStart = false;
let controlServer;
let communicator;
let playbackObj = {};
let mod = true;

class ReceiverI extends Ansjer.QReceiver
{
  showMoreMsg(avMoreMsg/* , current*/) {
    switch (avMoreMsg.ioCtrlType) {
      case AVIOCTRL.AVIOCTRL_IPCAM_START_RESP:
        postMessage([AVIOCTRL.AVIOCTRL_CONNECT_FAIL_RESP,[avMoreMsg.devUID, avMoreMsg.nChannelID, avMoreMsg.nErrorMsg, avMoreMsg.nResultFlag]]);
        break;
      case AVIOCTRL.AVIOCTRL_IPCAM_STOP_RESP:
        postMessage([AVIOCTRL.AVIOCTRL_CONNECT_FAIL_RESP,[avMoreMsg.devUID, avMoreMsg.nChannelID, avMoreMsg.nErrorMsg, avMoreMsg.nResultFlag]]);
        break;
      case AVIOCTRL.AVIOCTRL_IPCAM_START_LISTEVENT_REQ: {
        postMessage([AVIOCTRL.AVIOCTRL_CONNECT_FAIL_RESP,[avMoreMsg.devUID, avMoreMsg.nChannelID, avMoreMsg.nErrorMsg, avMoreMsg.nResultFlag]]);
      } break;
      case AVIOCTRL.AVIOCTRL_IPCAM_START_PLAYBACK_REQ: {
        postMessage([AVIOCTRL.AVIOCTRL_CONNECT_FAIL_RESP,[avMoreMsg.devUID, avMoreMsg.nChannelID, avMoreMsg.nErrorMsg, avMoreMsg.nResultFlag]]);
      } break;
      case AVIOCTRL.AVIOCTRL_IPCAM_STOP_PLAYBACK_REQ: {
        postMessage([AVIOCTRL.AVIOCTRL_CONNECT_FAIL_RESP,[avMoreMsg.devUID, avMoreMsg.nChannelID, avMoreMsg.nErrorMsg, avMoreMsg.nResultFlag]]);
      } break;
      default:
        console.log('showMoreMsg',avMoreMsg.ioCtrlType, avMoreMsg.nResultFlag,
          avMoreMsg.nChannelID, avMoreMsg.devUID, avMoreMsg.nErrorMsg, avMoreMsg.nReserved);
        break;
    }
  }
  setDeviceOnline(deviceUID, online/* , current*/) {
    postMessage([AVIOCTRL.AVIOCTRL_SET_DEVICE_ONLINE_RESP, [deviceUID, online]]);
  }
  setChannelOnline(bScene, deviceUID, channel, online/* , current*/) {
    postMessage([AVIOCTRL.AVIOCTRL_SET_CHANNEL_ONLINE_RESP, [bScene, deviceUID, channel, online]]);
  }
  recvMsg(ioCtrlType, bufMsg, nArray, nArraySize/* , current*/) {
    switch (ioCtrlType) {
      case AVIOCTRL.AVIOCTRL_IPCAM_START_RESP: {
        let bScene = Uint8ArrayToBoolean(bufMsg[0]);
        let devUID = Uint8ArrayToString(bufMsg.slice(nArray[0], nArray[0] + nArray[1]));
        let channelID = Uint8ArrayToNumber(bufMsg.slice(nArray[0] + nArray[1]), nArray[2]);
        postMessage([AVIOCTRL.AVIOCTRL_IPCAM_START_RESP, [bScene, devUID, channelID]]);
      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_STOP_RESP: {

      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_STOP_STREAM_RESP: {
        let devUID = Uint8ArrayToString(bufMsg.slice(0, nArray[0]));
        let channelID = Uint8ArrayToNumber(bufMsg.slice(nArray[0]), nArray[1]);
        postMessage([AVIOCTRL.AVIOCTRL_IPCAM_STOP_STREAM_RESP,[devUID, channelID]]);
      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_STOP_PLAYBACK_RESP: {

      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_PLAY_PAUSE_PLAYBACK_RESP: {

      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_PLAY_FORWARD_PLAYBACK_RESP: {

      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_START_LISTEVENT_RESP: {
        let devUID = Uint8ArrayToString(bufMsg.slice(0, nArray[0]));
        let channelID = parseInt(Uint8ArrayToString(bufMsg.slice(nArray[0], nArray[0] + nArray[1])));
        let nMsg = bufMsg.slice(nArray[0] + nArray[1], bufMsg.length);
        returnListEvent(nMsg, devUID, channelID, nArraySize);
      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_START_LANSEARCH_RESP: {
        let moreDev = [];
        if (nArraySize > 1) {
          let nPos = 0;
          for (let index = 0; index < nArraySize; index++) {
            let lanDevInfo = new Ansjer.LanSearchInfo2();
            lanDevInfo.Reserved = [0];
            let nLen = index * Object.keys(lanDevInfo).length;
            let nArr = nArray.slice(nLen, nArray.length);
            nPos = Uint8ArrayToClass(bufMsg, lanDevInfo, nArr, nPos);
            moreDev.push(lanDevInfo);
            //console.log('lanDevInfo', lanDevInfo, moreDev);
          }
        }
        postMessage([AVIOCTRL.AVIOCTRL_IPCAM_START_LANSEARCH_RESP,
          [moreDev.length, moreDev]]);
      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_START_PLAYBACK_RESP: {

      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_PLAY_BACKWARD_PLAYBACK_RESP: {

      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_UPDATE_CHANNEL_QUALITY_RESP: {
        let nPos = 0;
        let nQuality = new Ansjer.SMsgAVIoCtrlChangeQuality();
        nQuality.nReserved = [0, 0, 0, 0];
        nPos = Uint8ArrayToClass(bufMsg, nQuality, nArray, nPos);
        postMessage([AVIOCTRL.AVIOCTRL_IPCAM_UPDATE_CHANNEL_QUALITY_RESP,[nQuality.devUID, nQuality.nChannelID]]);
        //console.log('Device Quality', nQuality.bQuality, nQuality.nChannelID, nQuality.devUID, nQuality.nReserved);
      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_GET_DEVICE_VERSION_RESP: {
        let devUID = Uint8ArrayToString(bufMsg.slice(0, nArray[0]));
        let nVer = Uint8ArrayToNumber(bufMsg.slice(nArray[0]), nArray[1]);
        console.log('nVer', nVer, bufMsg);
        postMessage([AVIOCTRL.AVIOCTRL_IPCAM_GET_DEVICE_VERSION_RESP, [devUID, nVer]]);
      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_SOFTWAREVERSION_RESP: {
        let devUID = Uint8ArrayToString(bufMsg.slice(0, nArray[0]));
        let nVer = Uint8ArrayToString(bufMsg.slice(nArray[0]));
        //console.log('software version:', devUID, nVer);
      } break;

      case AVIOCTRL.AVIOCTRL_IPCAM_GET_PLAYBACK_STATUS_RESP: {
        let nPos = 0;
        let nPlayStatus = new Ansjer.SMsgAVIoctrlPlaybackPlayStatus();
        nPlayStatus.nReserved = [0, 0];
        nPos = Uint8ArrayToClass(bufMsg, nPlayStatus, nArray, nPos);
        postMessage([AVIOCTRL.AVIOCTRL_IPCAM_GET_PLAYBACK_STATUS_RESP, [nPlayStatus.devUID, nPlayStatus.nChannelID, nPlayStatus.bPlay]]);
      } break;

      default:
        console.log('ioCtrlType default', ioCtrlType, bufMsg, nArray, nArraySize);
        break;
    }
  }
  videoMsg(bScene, devUID, channelID, nLen, pVideo, nWidth, nHeight, frameNum, timestamp/* , current*/) {
    console.log('videoMsg', ioCtrlType, bufMsg, nArray, nArraySize);
  }
}

function sleep(seconds) {
  return new Promise(resolve => {
    setTimeout(resolve, 1000 * seconds);
  });
}

function msleep(milliseconds) {
  return new Promise(resolve => {
    setTimeout(resolve, milliseconds);
  });
}

function usleep(microseconds) {
  return new Promise(resolve => {
    setTimeout(resolve, microseconds / 1000);
  });
}

async function initiate() {
  let props = new Ice.InitializationData();
  props.properties = new Ice.createProperties();
  // props.properties.setProperty("Ice.Warn.Connections", "1");
  props.properties.setProperty('Ice.ACM.Client.Close', '3');
  props.properties.setProperty('Ice.ACM.Client.Heartbeat', '2');
  props.properties.setProperty('Ice.ACM.Client.Timeout', '30');
  props.properties.setProperty('Ice.Default.Host', 'localhost');
  props.properties.setProperty('Ice.MessageSizeMax', '204800000');
  props.properties.setProperty('Ice.ThreadPool.Client.Size', '1');
  props.properties.setProperty('Ice.ThreadPool.Client.SizeMax', '2');

  communicator = Ice.initialize(props);
  try {
    const nProxy = communicator.stringToProxy('QSender:ws  -p 10002');
    if (nProxy) {
      controlServer = await Ansjer.QControllerPrx.checkedCast(nProxy);
      if (controlServer) {
        const nAdapter = await communicator.createObjectAdapter('');
        const nReceiver = Ansjer.QReceiverPrx.uncheckedCast(nAdapter.add(
          new ReceiverI(), new Ice.Identity('Msg', '')));
        // const nReceiver = Ansjer.QReceiverPrx.uncheckedCast(nAdapter.
        // addWithUUID(new ReceiverI()));
        nAdapter.activate();
        controlServer.ice_getCachedConnection().setAdapter(nAdapter);
        await controlServer.erase(nReceiver);
        await controlServer.push(nReceiver);
        bStart = await controlServer.initServer();
        return [bStart];
      }
    } else {
      console.log('Invalid Proxy');
      return [bStart, 'Ice Invalid Proxy'];
    }
  } catch (error) {
    if (communicator) {
      await communicator.destroy();
    }
    return [bStart, error.toString()];
  }
}

async function waitForShutdown() {
  await communicator.waitForShutdown();
}

function hasChannel(devUID, channelID) {
  let result = [false];
  if (msgMap.has(devUID)) {
    msgMap.get(devUID)._moreChannel.forEach(value => {
      if (value._currentChannel === channelID) {
        result = [true, value];
      }
    });
  }
  return result;
}

async function startConnect(devUID, channelID, bScene) {
  if (msgMap.has(devUID)) {
    let nDevUID = msgMap.get(devUID);
    let nDev = new Ansjer.SMsgAVIoCtrlDevice();
    nDev.bScene = true;
    nDev.devUID = devUID;
    nDev.bScene = bScene;
    nDev.nChannelID = channelID;
    nDev.userName = 'admin';
    nDev.userPwd = nDevUID._password;
    nDev.nReserved = [0, 0, 0, 0];

    let total = nDev.devUID.length + nDev.userName.length + nDev.userPwd.length + 9;
    let array = [nDev.devUID.length, 4, 1, nDev.userName.length, nDev.userPwd.length, 4];
    let uint8Array = new Uint8Array(total);
    let uint8ArrayLen = new Uint8Array(6);
    uint8ArrayLen[0] = nDev.devUID.length;
    uint8ArrayLen[1] = 4; uint8ArrayLen[2] = 1;
    uint8ArrayLen[3] = nDev.userName.length;
    uint8ArrayLen[4] = nDev.userPwd.length;
    uint8ArrayLen[5] = 4;

    let pos = ClassToUint8Array(nDev, uint8Array, array);
    await controlServer.ioCtrlMsg(AVIOCTRL.AVIOCTRL_IPCAM_START_REQ, uint8Array, uint8ArrayLen);
  }
  return true;
}

async function stopConnect(devUID) {
  if (msgMap.has(devUID)) {
    let nMsgLen = new Uint8Array([devUID.length, 4]);
    let sMsg = new Uint8Array(devUID.length + 4);
    sMsg.set(stringToUint8Array(devUID,  devUID.length), 0);

    await controlServer.ioCtrlMsg(AVIOCTRL.AVIOCTRL_IPCAM_STOP_REQ, sMsg, nMsgLen);
  }
  return true;
}

async function stopStream(devUID, channelID) {
  if (controlServer) {
    let nMsgLen = new Uint8Array([devUID.length, 4]);
    let sMsg = new Uint8Array(devUID.length + 4);
    sMsg.set(stringToUint8Array(devUID,  devUID.length), 0);
    sMsg.set(numberToBytes(channelID, 4), devUID.length);

    await controlServer.ioCtrlMsg(AVIOCTRL.AVIOCTRL_IPCAM_STOP_STREAM_REQ, sMsg, nMsgLen);
  }
  return true;
}

async function  startListEvent(devUID, channelID, selectData) {
  let nPos = 0;
  let start = new Date(selectData);
  let end = new Date(selectData);
  start.setHours(0, 0, 0);
  end.setHours(23, 59, 59);

  const sMsg = new Uint8Array(devUID.length + 24);
  const lenArray = [devUID.length, 4, [2, 1, 1, 1, 1, 1, 1], [2, 1, 1, 1, 1, 1, 1], 1, 1, 2];
  let pListEvent = new Ansjer.AVIoCtrlListEventReq();
  pListEvent.devUID = devUID;
  pListEvent.channelID = channelID;
  pListEvent.stStartTime.year = start.getUTCFullYear();
  pListEvent.stStartTime.month = start.getUTCMonth() + 1;
  pListEvent.stStartTime.day = start.getUTCDate();
  pListEvent.stStartTime.hour = start.getUTCHours();
  pListEvent.stStartTime.minute = start.getUTCMinutes();
  pListEvent.stStartTime.second = start.getUTCSeconds();
  pListEvent.stEndTime.year = end.getUTCFullYear();
  pListEvent.stEndTime.month = end.getUTCMonth() + 1;
  pListEvent.stEndTime.day = end.getUTCDate();
  pListEvent.stEndTime.hour = end.getUTCHours();
  pListEvent.stEndTime.minute = end.getUTCMinutes();
  pListEvent.stEndTime.second = end.getUTCSeconds();
  pListEvent.reserved = new Uint8Array([0, 0]);

  let uint8ArrayLen = new Uint8Array(7);
  uint8ArrayLen[0] = devUID.length;
  uint8ArrayLen[1] = 4; uint8ArrayLen[2] = 8;
  uint8ArrayLen[3] = 8; uint8ArrayLen[4] = 1;
  uint8ArrayLen[5] = 1; uint8ArrayLen[6] = 2;

  nPos = ClassToUint8Array(pListEvent, sMsg, lenArray, nPos);
  await controlServer.ioCtrlMsg(AVIOCTRL.AVIOCTRL_IPCAM_START_LISTEVENT_REQ,
    sMsg, uint8ArrayLen);
}

async function startPlayRecord(devUID, channelID, dateValue) {
  //console.log('startPlayRecord', devUID, channelID, dateValue);
  let playRecord = new Ansjer.PlaybackRecord();
  playRecord.devUID = devUID;
  playRecord.channelID = channelID;
  playRecord.reserved = [channelID, 0, 0, 0];
  playRecord.stTimeDay.year = dateValue.getUTCFullYear();
  playRecord.stTimeDay.month = dateValue.getUTCMonth() + 1;
  playRecord.stTimeDay.day = dateValue.getUTCDate();
  playRecord.stTimeDay.hour = dateValue.getUTCHours();
  playRecord.stTimeDay.minute = dateValue.getUTCMinutes();
  playRecord.stTimeDay.second = dateValue.getUTCSeconds();
  playRecord.command = PLAY_CONTROL.RECORD_PLAY_START;

  let nArray = [devUID.length, 4, 4, 4, [2, 1, 1, 1, 1, 1, 1], 4];
  let sMsg = new Uint8Array(devUID.length + 24);
  let pos = ClassToUint8Array(playRecord, sMsg, nArray, 0);

  let uint8ArrayLen = new Uint8Array(6);
  uint8ArrayLen[0] = devUID.length; uint8ArrayLen[1] = 4;
  uint8ArrayLen[2] = 4; uint8ArrayLen[3] = 4;
  uint8ArrayLen[4] = 8; uint8ArrayLen[5] = 4;

  await controlServer.ioCtrlMsg(AVIOCTRL.AVIOCTRL_IPCAM_START_PLAYBACK_REQ,
    sMsg, uint8ArrayLen);
  return true;
}

async function stopPlayRecord(devUID, channelID) {
  let nMsgLen = new Uint8Array([devUID.length, 4]);
  let sMsg = new Uint8Array(devUID.length + 4);
  sMsg.set(stringToUint8Array(devUID,  devUID.length), 0);
  sMsg.set(numberToBytes(channelID, 4), devUID.length);
  await controlServer.ioCtrlMsg(AVIOCTRL.AVIOCTRL_IPCAM_STOP_PLAYBACK_REQ,
    sMsg, nMsgLen);
  return true;
}

async function lanSearch() {
  const sMsg = new Uint8Array(0);
  const arrayLen = new Uint8Array(0);
  await controlServer.ioCtrlMsg(AVIOCTRL.AVIOCTRL_IPCAM_START_LANSEARCH_REQ, sMsg, arrayLen);
  return true;
}
function returnListEvent(uint8Array, devUID, channelID, bOldVer) {
  if (msgMap.has(devUID)) {
    let playbackTime = {};
    let structureArray = [];
    if (bOldVer) {
      let pOld = new Ansjer.AVIoCtrlListEventRespOld();
      pOld.reserved = [0];
      pOld.stEvent = [new Ansjer.SAvEventOld()];
      pOld.stEvent[0].reserved = [0, 0];
      structureArray = [4, 4, 1, 1, 1, 1, [[2, 1, 1, 1, 1, 1, 1], 1, 1, 2]];

      if (JSON.stringify(playbackObj) === '{}') {
        playbackObj.isOld = true;
        playbackObj.playbackTime = [];
      }

      let pos = Uint8ArrayToClass(uint8Array, pOld, structureArray);
      if (pOld.count < 1) {
        const error = 'got rec list msg none rec list old ver!';
        postMessage([APP_MSG.SHOW_ERRORMSG_RESP, error]);
      }
      else {
        playbackTime = {};
        playbackTime.duration = 1000;
        playbackTime.time = pOld.stEvent[0].stTime;
        playbackObj.playbackTime.push(playbackTime);

        for (let index = 1; index < pOld.count; index++) {
          let sAvEvent = new Ansjer.SAvEventOld();
          sAvEvent.reserved = [0, 0];
          structureArray = [
            [2, 1, 1, 1, 1, 1, 1], 1, 1, 2
          ];
          pos = Uint8ArrayToClass(uint8Array, sAvEvent, structureArray, pos);
          pOld.stEvent.push(sAvEvent);

          playbackTime = {};
          playbackTime.duration = 1000;
          playbackTime.time = sAvEvent.stTime;
          playbackObj.playbackTime.push(playbackTime);
        }
        if (pOld.stEvent[0].stTime.hour === 23 && pOld.stEvent[1].stTime.hour < 23) {
          pOld.stEvent[0].stTime.day += 1;
          pOld.stEvent[0].stTime.hour = 16;
          pOld.stEvent[0].stTime.minute = 0;
          pOld.stEvent[0].stTime.second = 0;

          // console.log('Date after',  pOld.stEvent[0].stTime);
          playbackObj.playbackTime[0].time = pOld.stEvent[0].stTime;
        }
      }
      console.log('listEvent pOld = ', pOld, playbackObj);
    }
    else {
      let pNew = new Ansjer.AVIoCtrlListEventResp();
      pNew.reserved = [0];
      pNew.stEvent = [new Ansjer.SAvEvent()];
      pNew.stEvent[0].reserved = [0, 0];
      structureArray = [4, 4, 1, 1, 1, 1, [[2, 1, 1, 1, 1, 1, 1], 1, 1, 2, 4 ]];

      if (JSON.stringify(playbackObj) === '{}') {
        playbackObj.isOld = false;
        playbackObj.playbackTime = [];
      }

      let pos = Uint8ArrayToClass(uint8Array, pNew, structureArray);
      if (pNew.count < 1) {
        const error = 'No playback of data in this time period!';
        postMessage([APP_MSG.SHOW_ERRORMSG_RESP, error]);
      }
      else {
        if (pNew.stEvent[0].endflag === 0 && pNew.stEvent[0].stTime.hour === 23) {
          let one = new Date(),
            two = new Date();
          one.setUTCFullYear(pNew.stEvent[0].stTime.year);
          one.setUTCMonth(pNew.stEvent[0].stTime.month);
          one.setUTCDate(pNew.stEvent[0].stTime.day);
          one.setUTCHours(pNew.stEvent[0].stTime.hour);
          one.setUTCMinutes(pNew.stEvent[0].stTime.minute);
          one.setUTCSeconds(pNew.stEvent[0].stTime.second);
          two.setFullYear(pNew.stEvent[0].stTime.year);
          two.setMonth(pNew.stEvent[0].stTime.month);
          two.setDate(pNew.stEvent[0].stTime.day + 1);
          two.setHours(0, 0, 0);
          pNew.stEvent[0].stTime.day += 1;
          pNew.stEvent[0].stTime.hour = 16;
          pNew.stEvent[0].stTime.minute = 0;
          pNew.stEvent[0].stTime.second = 0;
          pNew.stEvent[0].duration = (two.valueOf() - one.valueOf()) / 1000;
          // console.log('Date after',  pNew.stEvent[0].stTime);
        }

        playbackTime = {};
        playbackTime.duration = pNew.stEvent[0].duration;
        playbackTime.time = pNew.stEvent[0].stTime;
        playbackObj.playbackTime.push(playbackTime);

        for (let index = 1; index < pNew.count; index++) {
          let sAvEvent = new Ansjer.SAvEvent();
          sAvEvent.reserved = [0, 0];
          structureArray = [
            [2, 1, 1, 1, 1, 1, 1], 1, 1, 2, 4
          ];
          pos = Uint8ArrayToClass(uint8Array, sAvEvent, structureArray, pos);
          pNew.stEvent.push(sAvEvent);

          playbackTime = {};
          playbackTime.duration = sAvEvent.duration;
          playbackTime.time = sAvEvent.stTime;
          playbackObj.playbackTime.push(playbackTime);
        }
      }
      console.log('listEvent pNew', pNew, playbackObj);
    }
    console.log('Get Playback List OK!');

    postMessage([APP_MSG.IPCAM_LISTEVENT_RESP, [devUID, channelID, playbackObj]]);
  }
}

async function test(devUID, channelID) {
  /*
  let nDev = new Ansjer.SMsgAVIoCtrlDevice();
  nDev.bScene = true;
  nDev.devUID = devUID;
  nDev.nChannelID = channelID;
  nDev.userName = 'admin';
  nDev.userPwd = 'qq111111';
  nDev.nReserved = [0, 0, 0, 0];

  let total = nDev.devUID.length + nDev.userName.length + nDev.userPwd.length + 9;
  let array = [nDev.devUID.length, 4, 1, nDev.userName.length, nDev.userPwd.length, 4];
  let uint8Array = new Uint8Array(total);
  let uint8ArrayLen = new Uint8Array(6);
  uint8ArrayLen[0] = nDev.devUID.length;
  uint8ArrayLen[1] = 4; uint8ArrayLen[2] = 1;
  uint8ArrayLen[3] = nDev.userName.length;
  uint8ArrayLen[4] = nDev.userPwd.length;
  uint8ArrayLen[5] = 4;
  console.log('uint8ArrayLen', uint8ArrayLen);
  let pos = ClassToUint8Array(nDev, uint8Array, array);
  await controlServer.ioCtrlMsg(1, uint8Array, uint8ArrayLen);
  */

  /*
  const date = new Date();
  const sMsg = new Uint8Array(devUID.length + 24);
  const lenArray = [devUID.length, 4, [2, 1, 1, 1, 1, 1, 1], [2, 1, 1, 1, 1, 1, 1], 1, 1, 2];
  let pListEvent = new Ansjer.AVIoCtrlListEventReq();
  pListEvent.devUID = devUID;
  pListEvent.channel = channelID;
  pListEvent.stStartTime.year = date.getUTCFullYear();
  pListEvent.stStartTime.month = date.getUTCMonth() + 1;
  pListEvent.stStartTime.day = date.getUTCDate();
  pListEvent.stStartTime.hour = date.getUTCHours();
  pListEvent.stStartTime.minute = date.getUTCMinutes();
  pListEvent.stStartTime.second = date.getUTCSeconds();
  pListEvent.stEndTime.year = date.getUTCFullYear();
  pListEvent.stEndTime.month = date.getUTCMonth() + 1;
  pListEvent.stEndTime.day = date.getUTCDate();
  pListEvent.stEndTime.hour = date.getUTCHours();
  pListEvent.stEndTime.minute = date.getUTCMinutes();
  pListEvent.stEndTime.second = date.getUTCSeconds();
  pListEvent.reserved = new Uint8Array([0, 0]);

  let uint8ArrayLen = new Uint8Array(6);
  uint8ArrayLen[0] = devUID.length;
  uint8ArrayLen[1] = 4; uint8ArrayLen[2] = 8;
  uint8ArrayLen[3] = 8; uint8ArrayLen[4] = 1;
  uint8ArrayLen[5] = 1; uint8ArrayLen[6] = 2;

  let pos = ClassToUint8Array(pListEvent, sMsg, lenArray, 0);
  console.log('uint8ArrayLen', uint8ArrayLen);
  await controlServer.ioCtrlMsg(AVIOCTRL.AVIOCTRL_IPCAM_START_LISTEVENT_REQ,
    sMsg, uint8ArrayLen);
    */

  /*
  本地设备搜索
  const sMsg = new Uint8Array(0);
  const arrayLen = new Uint8Array(0);
  await controlServer.ioCtrlMsg(0x7, sMsg, arrayLen);
  */
  return true;
}

async function setMod(isScene){
  if(controlServer){
    await controlServer.setCurrentArea(isScene);
    return true;
  }
  return false;
}

self.addEventListener('message', msg => {
  const control = msg.data[0];
  const resultValue = msg.data[1];
  switch (control) {
    case AVIOCTRL.AVIOCTRL_START_INIT_WORKER_REQ:
      initiate().then(data => {
        if (!data[0])
          close();
        postMessage([AVIOCTRL.AVIOCTRL_START_INIT_WORKER_RESP, data]);
        controlServer.setCurrentArea(mod);
        waitForShutdown().then({});
      });
      break;

    case AVIOCTRL.AVIOCTRL_IPCAM_START_REQ:
      startConnect(msg.data[1], msg.data[2], msg.data[3]).then( value => {} );
      break;

    case AVIOCTRL.AVIOCTRL_IPCAM_STOP_STREAM_REQ:
      stopStream(msg.data[1], msg.data[2]).then(value => {});
      break;

    case AVIOCTRL.AVIOCTRL_IPCAM_START_LANSEARCH_REQ: {
      lanSearch().then(value => {})
    } break;

    case AVIOCTRL.AVIOCTRL_IPCAM_START_LISTEVENT_REQ:
      playbackObj = {};
      startListEvent(resultValue[0], resultValue[1], resultValue[2]).then( value => {} );
      break;

    case AVIOCTRL.AVIOCTRL_IPCAM_START_PLAYBACK_REQ:
      startPlayRecord(resultValue[0], resultValue[1], resultValue[2]).then({});
      break;

    case  AVIOCTRL.AVIOCTRL_IPCAM_STOP_PLAYBACK_REQ:
      stopPlayRecord(resultValue[0], resultValue[1]).then({});
      break;

    case AVIOCTRL.AVIOCTRL_START_INIT_DATA_REQ:
      msgMap = resultValue;
      postMessage([AVIOCTRL.AVIOCTRL_START_INIT_DATA_RESP, true]);
      break;

    case AVIOCTRL.AVIOCTRL_STOP_WORKER_REQ:
      close();
      postMessage([AVIOCTRL.AVIOCTRL_STOP_WORKER_RESP, true]);
      break;

    case AVIOCTRL.AVIOCTRL_MOD_CHANGE_REQ:
      if(resultValue==='scene'){
        mod = true;
      }else{
        mod = false;
      }
      setMod(mod).then(val=>{
        postMessage([AVIOCTRL.AVIOCTRL_MOD_CHANGE_RESP, val]);
      });
      break;

    case AVIOCTRL.AVIOCTRL_IPCAM_STOP_REQ:
      stopConnect(resultValue).then(val=>{
        console.log('close session of dev:' + resultValue);
      });
      break;
  }
}, false);
