importScripts('polyfill.js', 'Ice.js', 'Ansjer.js', 'MsgType.js');

let avServer;
let mediaMap;
let bStart = false;
let communicator;

class ReceiverI extends Ansjer.QReceiver
{
  showMoreMsg(avMoreMsg/* , current*/) {}
  setDeviceOnline(deviceUID, online/* , current*/) {}
  setChannelOnline(bScene, deviceUID, channel, online/* , current*/) {}
  recvMsg(ioCtrlType, bufMsg, nArray, nArraySize/* , current*/) {}
  videoMsg(bScene, devUID, channelID, nLen, pVideo, nWidth, nHeight, frameNum, timestamp/* , current*/)  {
    const pVideoBuffer = pVideo.buffer;
    postMessage([CANVAS_MSG.CANVAS_DECODE_FINISHED,[bScene, devUID, channelID, nLen, pVideoBuffer, nWidth, nHeight, frameNum, timestamp]], [pVideoBuffer]);
    return;
  }
}

function sleep(seconds) {
  return new Promise(resolve => {
    setTimeout(resolve, 1000 * seconds);
  });
}

function msleep(milliseconds) {
  return new Promise(resolve => {
    setTimeout(resolve, milliseconds);
  });
}

function usleep(microseconds) {
  return new Promise(resolve => {
    setTimeout(resolve, microseconds / 1000);
  });
}

async function initiate() {
  let props = new Ice.InitializationData();
  props.properties = new Ice.createProperties();
  // props.properties.setProperty("Ice.Warn.Connections", "1");
  props.properties.setProperty('Ice.ACM.Client.Close', '3');
  props.properties.setProperty('Ice.ACM.Client.Heartbeat', '2');
  props.properties.setProperty('Ice.ACM.Client.Timeout', '30');
  props.properties.setProperty('Ice.Default.Host', 'localhost');
  props.properties.setProperty('Ice.MessageSizeMax', '204800000');
  props.properties.setProperty('Ice.ThreadPool.Client.Size', '1');
  props.properties.setProperty('Ice.ThreadPool.Client.SizeMax', '2');

  communicator = Ice.initialize(props);
  try {
    const nProxy = communicator.stringToProxy('QSender:ws  -p 10002');
    if (nProxy) {
      avServer = await Ansjer.QControllerPrx.checkedCast(nProxy);
      if (avServer) {
        const nAdapter = await communicator.createObjectAdapter('');
        const nReceiver = Ansjer.QReceiverPrx.uncheckedCast(nAdapter.add(
          new ReceiverI(), new Ice.Identity('Media', '')));
        // const nReceiver = Ansjer.QReceiverPrx.uncheckedCast(nAdapter.
        // addWithUUID(new ReceiverI()));
        nAdapter.activate();
        avServer.ice_getCachedConnection().setAdapter(nAdapter);
        await avServer.erase(nReceiver);
        await avServer.push(nReceiver);
        bStart = await avServer.initServer();
        return [bStart];
      }
    } else {
      console.log('Invalid Proxy');
      return [bStart, 'Ice Invalid Proxy'];
    }
  } catch (error) {
    if (communicator) {
      await communicator.destroy();
    }
    return [bStart, error.toString()];
  }
}

async function waitForShutdown() {
  await communicator.waitForShutdown();
}

self.addEventListener('message', msg => {
  const control = msg.data[0];
  const resultValue = msg.data[1];
  switch (control) {
    case AVIOCTRL.AVIOCTRL_START_INIT_WORKER_REQ:
      initiate().then(data => {
        if (!data[0])
          close();
        postMessage([AVIOCTRL.AVIOCTRL_START_INIT_WORKER_RESP, data]);
        waitForShutdown().then({});
      });
      break;

    case AVIOCTRL.AVIOCTRL_START_INIT_DATA_REQ:
      mediaMap = resultValue;
      postMessage([AVIOCTRL.AVIOCTRL_START_INIT_DATA_RESP, true]);
      break;

    case AVIOCTRL.AVIOCTRL_STOP_WORKER_REQ:
      close();
      postMessage([AVIOCTRL.AVIOCTRL_STOP_WORKER_RESP, true]);
      break;
  }
}, false);
